/*add by  liuxu*/

/*用于和帝馨app的对接问题*/
function setupWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) {
        return callback(WebViewJavascriptBridge);
    }
    if (window.WVJBCallbacks) {
        return window.WVJBCallbacks.push(callback);
    }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'wvjbscheme://__BRIDGE_LOADED__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function () {
        document.documentElement.removeChild(WVJBIframe)
    }, 0)
};


var javascriptHandler = 'javascriptHandler';//设置移动端调用Js方法（函数）的关键字，固定不变

/*判断是否是帝馨app*/
function isCyhAPP() {

    var str = navigator.userAgent.toLowerCase();
    return str.indexOf("desn_ios") > -1 || str.indexOf("desn_android") > -1;
    //return true;
}

var lastTrackMacId;
(function () {

    //执行setupWebViewJavascriptBridge方法, 并用bridge去注册handler
    setupWebViewJavascriptBridge(function (bridge) {
        //注册（初始化）移动端调用Js中的方法（函数），js处理完成后，回调通知移动端
        bridge.registerHandler(javascriptHandler, function (data/*移动端传过来的参数，json数据格式*/, responseCallback) {
            if (data != null && data != "") {
                var json = JSON.parse(data);//{ "moduleName": "Notification", "data": [{ "messageType": "2" }] }
                var msg = json.data[0];
                if (json.moduleName == "AlarmLoc") {
                    mapCtrl.alarmLoc(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.center, msg.mapType, msg.msg);
                    mapCtrl.getAddress(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.mapType, responseCallback);
                } else if (json.moduleName.indexOf("FenceLoc") != -1) {
                    mapCtrl.addFenceLoc(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.mapType, parseFloat(msg.radius));
                    if (json.moduleName.indexOf("Device") != -1) {
                        mapCtrl.deviceLoc(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.center, msg.mapType, msg.icon, msg.msg,parseFloat(msg.hangxiang),msg.pop);
                    } else if (json.moduleName.indexOf("Phone") != -1) {
                        mapCtrl.currentLocation(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.center, msg.mapType, msg.msg);
                    }
                    mapCtrl.getAddress(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.mapType, responseCallback);
                } else if (json.moduleName == "DeviceLoc") {
                    mapCtrl.deviceLoc(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.center, msg.mapType, msg.icon, msg.msg,parseFloat(msg.hangxiang));
                    mapCtrl.getAddress(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.mapType, responseCallback);
                } else if (json.moduleName == "Satellite") {
                    mapCtrl.satellite(msg.satellite);
                } else if (json.moduleName == "Traffic") {
                    mapCtrl.trafficLayer(msg.traffic);
                } else if (json.moduleName == "CurrentLocationRotate") {
                    mapCtrl.currentLocationRotate(parseFloat(msg.currentLocationRotate));
                } else if (json.moduleName == "PhoneLoc") {
                    mapCtrl.currentLocation(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.center, msg.mapType, msg.msg,msg.icon,parseFloat(msg.hangxiang));
                } else if (json.moduleName == "Track") {
                    if (lastTrackMacId != null && lastTrackMacId != msg.macId) {
                        mapCtrl.cleanTrack();
                        msg.center = true;
                    }
                    lastTrackMacId = msg.macId;
                    mapCtrl.deviceLoc(parseFloat(msg.latitude), parseFloat(msg.longitude), false, msg.mapType, msg.icon, msg.msg,parseFloat(msg.hangxiang));
                    if(msg.isEnable||typeof (msg.isEnable) == "undefined"){
                        mapCtrl.track(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.center, msg.mapType, msg.msg,msg.lineColor);
                    }
                    mapCtrl.getAddress(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.mapType, responseCallback);
                } else if (json.moduleName == "cleanTrack") {
                    mapCtrl.cleanTrack();
                } else if (json.moduleName == "ScaleZoom") {
                     mapCtrl.scaleZoom(msg.arithmeticOperator);
                 } else if (json.moduleName == "DrawHistoryLines") {
                    mapCtrl.drawLines(msg.latLngs, msg.mapType);
                } else if (json.moduleName == "PlayBackTrack") {
                    if (msg.index <= 1) {
                        mapCtrl.cleanTrack();
                        msg.center = true;
                    }
                    mapCtrl.deviceLoc(parseFloat(msg.latitude), parseFloat(msg.longitude), false, msg.mapType, msg.icon, msg.msg,parseFloat(msg.hangxiang));
                    mapCtrl.track(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.center, msg.mapType, msg.msg);
                    mapCtrl.getAddress(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.mapType, responseCallback);
                } else if (json.moduleName == "AddMarkers") {
                    mapCtrl.addMarkerTypes(msg.stays, msg.lbses, msg.wifis, msg.mapType);
                } else if (json.moduleName == "VisibleMarkers") {
                    mapCtrl.removeMarkerTypes(msg.visible, msg.markerType);
                } else if (json.moduleName == "AddMarker") {
                    mapCtrl.addMarkerType(msg.markerInfo, msg.markerType, msg.mapType);
                } else if (json.moduleName == "onDestroy") {
                    mapCtrl.onDestroy();
                } else if (json.moduleName == "DrawDistanceLineBetweenTwoPlaces") {
                    mapCtrl.drawDistanceLineBetweenTwoPlaces(parseFloat(msg.startlat), parseFloat(msg.startlng), parseFloat(msg.endLat), parseFloat(msg.endLng), msg.mapType, msg.color, msg.isBounds);
                } else if (json.moduleName == "ClearDistanceLineBetweenTwoPlacesOverlayOptions") {
                    mapCtrl.clearDistanceLineBetweenTwoPlacesOverlayOptions();
                } else if (json.moduleName == "LinePlanning") {
                    mapCtrl.currentLocation(parseFloat(msg.locLatitude), parseFloat(msg.locLongitude),msg.center,msg.mapType,msg.msg);
                    mapCtrl.linePlanning(parseFloat(msg.locLatitude), parseFloat(msg.locLongitude), parseFloat(msg.latitude), parseFloat(msg.longitude), msg.center, msg.mapType, msg.msg);
                } else if (json.moduleName == "MoreDevicesToMap") {
                    mapCtrl.addMoreDeviceMarkers(msg.moreDevices, msg.mapType,msg.fitBounds,msg.selMacId,msg.firstShowPopInfoWindow);
//                        mapCtrl.currentLocation(parseFloat(msg.locLatitude), parseFloat(msg.locLongitude),msg.center,msg.mapType,msg.msg);
                } else if (json.moduleName == "SelTheFirstFewDevice") {
                    mapCtrl.showSelTheFirstFewDeviceMsg(msg.macId, msg.msg,msg.isCenter);
//                        mapCtrl.currentLocation(parseFloat(msg.locLatitude), parseFloat(msg.locLongitude),msg.center,msg.mapType,msg.msg);
                } else if (json.moduleName == "ShowStreetView") {
                    mapCtrl.showStreetView(parseFloat(msg.latitude), parseFloat(msg.longitude), msg.mapType);
                }
            } else {
                //console.log('移动端说：', data);
                var responseData = {'Js说': '好的，没问题!'};
                //console.log('JS响应', responseData);
                responseCallback(responseData); //处理完成回调通知移动端
            }

        });
    });

})();


var mobileTerminalCallback = 'mobileTerminalCallback';//设置Js调用移动端方法（函数）的关键字，固定不变
var bridgeInterface = {

    applocation: function () {
        setupWebViewJavascriptBridge(function (bridge) {

            var module = {"moduleName": "GetLocation", "data": []};
            var moduleJson = JSON.stringify(module);

            bridge.callHandler(mobileTerminalCallback, moduleJson, function (response) {
                //alert(response);
                response = JSON.parse(response);
                var str = response.data[0];
                if (str) {
                    mapCtrl.currentLocation(parseFloat(str.latitude), parseFloat(str.longitude));
                } else {
                    alert('APP定位失败');
                }
            });

        });
    },

    FenceLatLng: function (lat, lng) {

        setupWebViewJavascriptBridge(function (bridge) {

            var module = {"moduleName": "FenceLatLng", "data": [{"lat": lat, "lng": lng}]};
            var moduleJson = JSON.stringify(module);

            bridge.callHandler(mobileTerminalCallback, moduleJson, function (response) {

            });
        });
    },

    LatlngCallback: function (lat, lng, macId) {

        setupWebViewJavascriptBridge(function (bridge) {
            if (macId == null || macId == undefined) {
                macId = "";
            }
            var module = {"moduleName": "LatlngCallback", "data": [{"lat": lat, "lng": lng, "macId": macId}]};
            var moduleJson = JSON.stringify(module);

            bridge.callHandler(mobileTerminalCallback, moduleJson, function (response) {

            });
        });
    },

    OnMapLoadedCallback: function () {

        setupWebViewJavascriptBridge(function (bridge) {

            var module = {"moduleName": "OnMapLoadedCallback", "data": []};
            var moduleJson = JSON.stringify(module);

            bridge.callHandler(mobileTerminalCallback, moduleJson, function (response) {

            });
        });
    }


};







